#include <stdio.h>
#include <math.h>

/*************************************************************************/

void naive_fft3d(int n, double (*gen_re)(int, int, int, int), 
		 double (*gen_im)(int, int, int, int), char *outfile);
double gen_re(int n, int i, int j, int k);
double gen_im(int n, int i, int j, int k);

/*************************************************************************/

main(int argc, char **argv)
{

  /* just tests that it has the necessary input and then */
  /* calls the function for computing the 3d dft         */

  if (argc != 3) {
    fprintf(stderr,"format: fft3d_driver n outfile\n");
    exit(-1);
  }
  else {
    naive_fft3d(atoi(argv[1]), gen_re, gen_im, argv[2]);
  }

}

/**************/
/*** gen_re ***/
/**************/

/*
 * IN : n - parameter
 *      i - parameter
 *      j - parameter
 *      k - parameter
 * OUT: some function of n, i, j, k
 * MOD:
 * REQ: n > 0
 *      0 <=i <n
 *      0 <=j <n
 *      0 <=k <n
 */

double gen_re(int n, int i, int j, int k)
{
  double answer;
  
  answer = sin((double)i*2.0*M_PI/(double)n) *
    sin((double)j*2.0*M_PI/(double)n) * sin((double) k*2.0*M_PI/(double)n);

  return answer;
}

/**************/
/*** gen_im ***/
/**************/

/*
 * IN : n - parameter
 *      i - parameter
 *      j - parameter
 *      k - parameter
 * OUT: some function of n, i, j, k
 * MOD:
 * REQ: n > 0
 *      0 <=i <n
 *      0 <=j <n
 *      0 <=k <n
 */

double gen_im(int n, int i, int j, int k)
{
  double answer;

  answer = 0.0;
  
  return answer;
}

